com.tibbo.aggregate.common.expression

## Class Expression

- java.lang.Object
- - com.tibbo.aggregate.common.expression.Expression

- All Implemented Interfaces:
    PinpointAware, PublicCloneable, java.lang.Cloneable

      public class Expression
      extends java.lang.Object
      implements java.lang.Cloneable, PublicCloneable, PinpointAware

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `REFERENCE_END`
    `static java.lang.String` | `REFERENCE_START`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Expression(Reference reference)` Creates Expression that consists of single reference
    `Expression(java.lang.String text)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `assignPinpoint(Pinpoint pinpoint)` Assigns this object with the given pinpoint
    `Expression` | `clone()`
    `boolean` | `equals(java.lang.Object obj)`
    `ASTStart` | `getRootNode()`
    `java.lang.String` | `getText()`
    `int` | `hashCode()`
    `java.util.Optional<Pinpoint>` | `obtainPinpoint()`
    `void` | `setRootNode(ASTStart rootNode)`
    `java.lang.String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.tibbo.aggregate.common.structure.PinpointAware

      `assignPinpoint, removePinpoint`

- - ### Field Detail

    - #### REFERENCE_START

          public static final java.lang.String REFERENCE_START

      See Also:
        Constant Field Values

    - #### REFERENCE_END

          public static final java.lang.String REFERENCE_END

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### Expression

          public Expression(Reference reference)

      Creates Expression that consists of single reference
      Parameters:
        `reference` - Reference

    - #### Expression

          public Expression(java.lang.String text)

  - ### Method Detail

    - #### getText

          public java.lang.String getText()

    - #### getRootNode

          public ASTStart getRootNode()

    - #### setRootNode

          public void setRootNode(ASTStart rootNode)

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `java.lang.Object`

    - #### equals

          public boolean equals(java.lang.Object obj)

      Overrides:
        `equals` in class `java.lang.Object`

    - #### clone

          public Expression clone()

      Specified by:
        `clone` in interface `PublicCloneable`
      Overrides:
        `clone` in class `java.lang.Object`

    - #### assignPinpoint

          public void assignPinpoint(Pinpoint pinpoint)

      Description copied from interface: `PinpointAware`
      Assigns this object with the given pinpoint
      Specified by:
        `assignPinpoint` in interface `PinpointAware`
      Parameters:
        `pinpoint` - a pinpoint this object should be associated with

    - #### obtainPinpoint

          public java.util.Optional<Pinpoint> obtainPinpoint()

      Specified by:
        `obtainPinpoint` in interface `PinpointAware`